#/bin/sh
#Threshold plugin 1.0 for cacti 8.5a
#
# Copyright 2004 Aurelio DeSimone
# adesimone@ciscoconfigbuilder.com
# 
# Use at your own risk.  NO Warranty or Guarantee given.
#
# Some code may have been used from other parts of cacti - copyright of Ian Berry
#

#define variables
cactibasedir=/var/www/html/cacti
rootdir=$cactibasedir/thold
httpurl=http://127.0.0.1/cacti
logdir=/var/log
elementcache="$rootdir/state"

lookup=$cactibasedir/include/config.php

cactidbname=`grep database_default $lookup | awk -F '"' '{print $2}'`
cacti_database_username=`grep database_username $lookup | awk -F '"' '{print $2}'`
cacti_database_password=`grep database_password $lookup | awk -F '"' '{print $2}'`



#extract email destination from database
emailadd=`mysql --skip-column-names -t cacti < $rootdir/tholdset.sql | grep -v + | awk '{print $4}'`
#extract data from database
mysql --user=$cacti_database_username --password=$cacti_database_password --skip-column-names -t cacti < $rootdir/read.sql | grep -v + > $rootdir/buffer.txt
#clean up buffer
replace "|" ":" -- $rootdir/buffer.txt
replace " " "" -- $rootdir/buffer.txt
# begin new sql update file w/ time stamp
echo "UPDATE tholdset SET datet=NOW() WHERE id='1';" > $rootdir/updates.sql

for a in `cat $rootdir/buffer.txt`
do
#parse data
element=`echo $a | awk -F ":" '{print $3}'`
elementip=`echo $a | awk -F ":" '{print $4}'`
elementid=`echo $a | awk -F ":" '{print $5}'`
threshld=`echo $a | awk -F ":" '{print $6}' | awk '{print $1}'`
rra=`echo $a | awk -F ":" '{print $7}' | awk '{print $1}'`
currentval=`grep _$rra.rrd $logdir/cacti.log | awk -F : '{print $NF}' | awk '{printf("%d\n",$1 + 0.5);}'`
#go to work
if [ -f $elementcache/$rra.txt ]
        then
         echo ""
        else
         echo "0" > $elementcache/$rra.txt
fi

alertstat=`cat $elementcache/$rra.txt`

if [ $currentval -gt $threshld ]
        then
                if [ $alertstat -eq 1 ]
                        then
                        logger "$element exceeded $threshld with $currentval"
			echo "UPDATE thold SET lastread='$currentval' WHERE rra='$rra';" >> $rootdir/updates.sql
                else
                        logger "$element exceeded threshold of $threshld with $currentval"
			echo "$httpurl/cactistoric.php?local_graph_id=$elementid&rra_id=1" > $rootdir/mailout.txt
                        mail -s "$element exceeded threshold of $threshld with $currentval" $emailadd < $rootdir/mailout.txt
			echo "UPDATE thold SET ipadd='1' WHERE rra='$rra';" >> $rootdir/updates.sql
			echo "UPDATE thold SET lastread='$currentval' WHERE rra='$rra';" >> $rootdir/updates.sql
                        echo "1" > $elementcache/$rra.txt
                fi

        else
                if [ $alertstat -eq 1 ]
                        then
                        logger "$element fell below threshold of $threshld with $currentval"
                        mail -s "$element fell below threshold of $threshld with $currentval" $emailadd <$elementcache/$rra.txt
                        echo "0" > $elementcache/$rra.txt
			echo "UPDATE thold SET ipadd='0' WHERE rra='$rra';" >> $rootdir/updates.sql
			echo "UPDATE thold SET lastread='$currentval' WHERE rra='$rra';" >> $rootdir/updates.sql
                else
                        echo "0" > $elementcache/$rra.txt
			echo "UPDATE thold SET ipadd='0' WHERE rra='$rra';" >> $rootdir/updates.sql
			echo "UPDATE thold SET lastread='$currentval' WHERE rra='$rra';" >> $rootdir/updates.sql
                fi
fi
done

#update states
mysql cacti < $rootdir/updates.sql

#cleanup
rm -rf $rootdir/updates.sql
rm -rf $rootdir/buffer.txt
rm -rf $rootdir/mailout.txt
