#/bin/sh
# Threshold plugin 1.0 for cacti 8.5a
#
# Copyright 2004 Aurelio DeSimone
# adesimone@ciscoconfigbuilder.com
# 
# Use at your own risk.  NO Warranty or Guarantee given.
#
# Some code may have been used from other parts of cacti - copyright of Ian Berry
#

#define some stuff
if [ "$1" != "" ]
        then
                echo "Installing into $1"
        else
                echo "Error - wrong syntax - you must specify cacti root directory ie: install.sh /var/www/html/cacti"
                exit
fi

# make sure we are launched in coreect directory
pwd=`pwd`

if [ "$pwd" == "$1/thold" ]
	then
		echo "Directory check ok"
	else
		echo "Directory check failed.  Please make sure you are launching script from $1/thold"
		exit
fi


# make sure we aren't installing twice
checkold=`grep thold ../* | wc -l | awk '{print $1}'`

if [ $checkold -eq 0 ]
	then
		echo "This is a new install.."
	else
		echo "An installation seems already be present.  Quitting"
		exit
fi




cactibasedir=$1
#cactidbname=cacti

lookup=$cactibasedir/include/config.php

cactidbname=`grep database_default $lookup | awk -F '"' '{print $2}'`
database_username=`grep database_username $lookup | awk -F '"' '{print $2}'`
database_password=`grep database_password $lookup | awk -F '"' '{print $2}'`

#mysql check
echo "show tables;" > quit.txt
checkdbconn=`mysql $cactidbname --user=$database_username --password=$database_password  < quit.txt | grep host_template_snmp_query | wc -l | awk '{print $1}'`
if [ $checkdbconn -eq 1 ]
        then
                echo "DB login OK"
        else
                if [ "$2" == "" ]
                        then
                                echo "Database login failed.  Please specify cacti database login - i.e. install.sh /var/www/html/cacti cactiuer cactipass"
				exit
                        else
                                echo "database username and pass given"
                                checkdbagain=`mysql $cactidbname --user=$2 --password=$3 < quit.txt | grep host_template_snmp_query | wc -l | awk '{print $1}'`
                                if [ $checkdbagain -eq 1 ]
                                        then
                                                echo "DB login OK"
						database_username=$2
						database_password=$3
                                        else
						echo "**************************************************************"
                                                echo "WARNING: - Database login still failed - "
                                                echo "You will have to import manually using 'mysql cacti < thold.sql"
						echo "**************************************************************"
                                fi
                fi
fi
rm -rf quit.txt

echo " "
echo "WARNING: you may want to backup files & cacti database before proceeding."
echo "An uninstall script is provided to remove & restore modified files."
echo "Use at your own risk.  NO Warranty or Guarantee given."
echo "If you continue, you agree not to hold me liable for damages or loss of data."
echo "press CTRL+C in the next 5 seconds to stop"
sleep 6
echo " "

# backup first
echo "Backing up files..."
cp $cactibasedir/data_sources.php $cactibasedir/data_sources.php.bak
cp $cactibasedir/lib/functions.php $cactibasedir/lib/functions.php.bak
cp $cactibasedir/include/config_arrays.php $cactibasedir/include/config_arrays.php.bak
cp $cactibasedir/include/top_header.php $cactibasedir/include/top_header.php.bak
cp $cactibasedir/include/top_graph_header.php $cactibasedir/include/top_graph_header.php.bak
cp $cactibasedir/lib/rrd.php $cactibasedir/lib/rrd.php.bak
cp $cactibasedir/graph.php $cactibasedir/graph.php.bak
cp $cactibasedir/graph_image.php $cactibasedir/graph_image.php.bak

# modify files
echo "Modifying files..."
replace "127.0.0.1" "$HOSTNAME" -- check-thold.sh

# add table
echo "Adding SQL tables..."
echo "
CREATE TABLE thold (
  id mediumint(8) NOT NULL auto_increment,
  description varchar(50) default NULL,
  ipadd varchar(20) default NULL,
  element varchar(50) default NULL,
  threshold int(50) default NULL,
  rra int(11) default NULL,
  lastread int(50) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE tholdset (
  id mediumint(8) NOT NULL auto_increment,
  emailadd varchar(50) default NULL,
  datet datetime default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

INSERT INTO tholdset VALUES (1,'root@localhost','2004-12-12 00:55:55');
" > thold.sql

mysql $cactidbname --user=$database_username --password=$database_password < thold.sql
#rm -rf thold.sql

# install files
echo "Installing new files..."
mv thold.php $cactibasedir/
mv listthold.php $cactibasedir/
mv tab_thold.gif $cactibasedir/images/
mv graph_thold.php $cactibasedir/
mv cactistoric.php $cactibasedir/
mv config_arrays.php $cactibasedir/include/
mv data_sources.php $cactibasedir/
mv functions.php $cactibasedir/lib/
mv graph_image.php $cactibasedir/
mv graph.php $cactibasedir/
mv rrd.php $cactibasedir/
mv top_graph_header.php $cactibasedir/include/
mv top_header.php $cactibasedir/include/


mkdir $cactibasedir/thold/state
echo "SELECT * FROM thold;" > read.sql
echo "SELECT * FROM tholdset;" > tholdset.sql
echo "*************************************************************************************************** "
echo "installation complete.  MAKE SURE YOU MODIFY YOUR CRONTAB (crontab -e on most systems):"
echo " "
echo "Replace the line:"
echo "*/5 * * * * php $1/cmd.php > /dev/null > /dev/null 2>&1"
echo "With:"
echo "*/5 * * * * php $1/cmd.php > /var/log/cacti.log && $1/thold/check-thold.sh > /dev/null 2>&1"
echo "**************************************************************************************************** "
